#include <stdarg.h>
#include <errno.h>
#include <stdio.h>
#include <assert.h>

#include <string.h>
#include <unistd.h>

#include "log.h"

// #define print_log(x) 

static FILE *flog;

void log_open() {
  assert(flog == NULL);
  flog = fopen("log", "a");
  if(flog == NULL) {
    printf("unable to open log file: %s\n", strerror(errno));
  }
  LOG("Log file opened.\n");
}

static char buf[256];
void log_print(const char *file, int line, const char *message, ...) {
  va_list arguments;
  va_start(arguments, message);
  snprintf(buf, 256, "%s:%d %d %s", file, line, getpid(), message);
  if(flog != NULL) {
    (void)vfprintf(flog, buf, arguments);
    fflush(flog);
  } else 
    (void)vprintf(buf, arguments);
}

void log_close() {
  (void)fclose(flog);
}
